<template>



	 <div class="cg-product-grid-wrap font1">
                <div class="cg-dash-items-grid cg-border-top" >

  <div v-if="loading" class="loading">
     <img src="/images/miniloader.svg" class="img-fluid" alt="creativegoods">
  </div>
  <div v-else>
        <div class="cg-empty-wrap" v-cloak v-if="isEmpty">
             <div class="cg-empty-content-wrap text-center add-btm-mdm">
                 <img src="/images/no-items.svg" alt="creativegoods" class="img-ﬂuid width-30">
                 <h4 class="font1 grey f18 w500 pad-top-mdm pad-btm-xsml">You don't have any downloads yet.</h4>
                 <a href="/all-items" class="ﬁrst theme-bg f14 w600">Browse Products</a>
             </div>
         </div>

                    <div class="row" v-cloak v-if="!isEmpty">
                        <div class="col-md-6 d-flex"  v-for="download in products_">
                            <div class="cg-product-dp col-md-3"><img class="img-fluid" :src="download.product.cover_photo_path" :alt="download.product.name" data-no-retina></div>
                            <div class="cg-product-name col-md-9">
                                <a :href="download.product.product_url" class="second">{{ download.product.name | subStrName }}</a>
                                <p>{{ download.date_added }}</p>
                                <input type="radio"   value="0" id="star-null" hidden="">
                                <input type="radio"   value="1" v-on:click="rateMyItem(download.product.id,1)" :id="'star-1'+download.id"  hidden="">
                                <input type="radio"  value="2"  v-on:click="rateMyItem(download.product.id,2)" :id="'star-2'+download.id"   hidden="">
                                <input type="radio"   value="3"  v-on:click="rateMyItem(download.product.id,3)" :id="'star-3'+download.id"  hidden="">
                                <input type="radio"   value="4"  v-on:click="rateMyItem(download.product.id,4)" :id="'star-4'+download.id"   hidden="">
                                <input type="radio"  value="5"  v-on:click="rateMyItem(download.product.id,5)" :id="'star-5'+download.id"   hidden="">
                                <div class="strwrap d-flex additional-btns cg-product-star-rating">
                                    <label :for="'star-1'+download.id">
                                        <svg class="f13 feather feather-star" v-bind:class = "(download.product.total_average_rating >=1)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                                    </label>
                                    <label :for="'star-2'+download.id">
                                        <svg class="f13 feather feather-star" v-bind:class = "(download.product.total_average_rating >=2)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                                    </label>
                                    <label :for="'star-3'+download.id">
                                        <svg class="f13 feather feather-star" v-bind:class = "(download.product.total_average_rating >=3)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                                    </label>
                                    <label :for="'star-4'+download.id">
                                        <svg class="f13 feather feather-star" v-bind:class = "(download.product.total_average_rating >=4)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                                    </label>
                                    <label :for="'star-5'+download.id">
                                        <svg class="f13 feather feather-star" v-bind:class = "(download.product.total_average_rating >=5)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                                    </label>
                                </div>
                                <span v-if="download.total_price">${{ download.total_price }}</span><span v-if="!download.total_price">Free</span>
                                <ul class="d-flex additional-btns cg-product-star-rating">
                                    <li class="cg-tiny-download">
                                          <a :href="user_.user_url+'/download-my-item?i=' + download.product_id+'&j='+fake_id" target="_blank" class="cg-dash-items-download-btn">Download</a>
                                    </li>
                                </ul>


                            </div>
                        </div>

                    </div>
                    </div>
                </div>
         <ShopPagination v-if="pagination.last_page > 1" :pagination="pagination" :offset="5" @paginate="fetchMyDownloads()" ></ShopPagination>



         <div class="cg-toast-one" v-if="success_message">
             <ul class="d-flex justify-content-between">
                 <li class="first"><p>{{ success_message }}</p></li>
                 <li class="first"><a class="kill-toast fa fa-times" aria-hidden="true"></a></li>
             </ul>
         </div>

         <div class="cg-toast-one" v-if="error_message">
             <ul class="d-flex justify-content-between">
                 <li class="first"><p>{{ error_message }}</p></li>
                 <li class="first"><a class="kill-toast fa fa-times" aria-hidden="true"></a></li>
             </ul>
         </div>
            </div>
</template>
<style lang="scss" scoped>
.cg-product-grid-wrap{
    min-height: 300px;
}
[v-cloak] {
  display: none;
}
.loading {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 400px;
}
</style>
<script>
    import Preloader from '../components/Preloader.vue';
    import ShopPagination from '../components/ShopPagination.vue';
    export default {
        props: ['user', 'message', 'countries'],

  created(){
    setTimeout(() => {
      this.loading = false;
    },1000);
  },
        data(){
            return{
                isEmpty: true,
                user_:JSON.parse(this.user),
                countries_:JSON.parse(this.countries),
                message_:this.message,
                products_:{},
                success_message:'',
                error_message:'',
                fake_id:0,
                isEmpty:false,
    loading: true,
                pagination: {
                    'current_page': 1
                },
            }

        },
        components:{
            ShopPagination,
            Preloader
        },
        methods: {
            loadJs(url, callback) {
                jQuery.ajax({
                    url: url,
                    dataType: 'script',
                    success: callback,
                    async: true
                });
            },

            fetchMyDownloads() {
                this.preLoad() ;
                axios.get('/get_my_downloads?page=' + this.pagination.current_page)
                    .then(response => {
                        this.products_ = response.data.data.data;
                        this.pagination = response.data.pagination;
                        if(this.products_.length ){
                            this.isEmpty=false;
                        }else{
                            this.isEmpty=true;
                        }
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            downloadMyItem(product_id)
            {
                alert(product_id)
                axios.get('/download_my_items?product_id=' + product_id)
                    .then(response => {
                       alert('success')
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            rateMyItem(product_id, rating)
            {
                let currentObj = this;
                currentObj.success_message='';
                currentObj.error_message='';

                const config = {
                    headers: {
                        'content-type':'application/json',
                        'Accept':'application/json'
                    }
                }

                let formData = new FormData();
                formData.append('product_id',  product_id);
                formData.append('rating',  rating);

                axios.post('/rate_my_item', formData, config).then((response)=>{

                    if(response.data.status == 'success')
                    {
                        currentObj.success_message = response.data.message
                        this.fetchMyDownloads();
                    }
                    else
                    {
                        currentObj.error_message = response.data.message
                        this.fetchMyDownloads();
                    }
                    this.loadJs('/javascripts/custom/toast.js', function() {
                        //Stuff to do after someScript has loaded
                    });
                })
            },

             preLoad: function(){
              // just open
              const close = this.$preloaders.open({
                container: ".cg-product-grid-wrap",
                component:Preloader,
                // cssClass: 'test' ,
                  "overlayStyle": {
                    "backgroundColor": "#fff",
                    "opacity": .1,
                  }

                // assetStyle: {
                //   width: "100px",
                //   height:"400px",
                // },
                // overlayStyle: {
                //   backgroundColor: "#4bc5b3",
                //   opacity: 1
                // }
              });

              // and close. That's it.
              setTimeout(close, 1500);
            }
        },
        filters: {

            subStrName: function(string)
            {
                if(string.length >31)
                {
                    return string.substring(0,28) + '...';
                }
                else
                {
                    return string.substring(0,31);
                }
            },



        },
        mounted(){
            this.fake_id = Math.floor(100000 + Math.random() * 900000);
            this.fetchMyDownloads();
             // this.preLoad() ;

        },
          watch: {

            pageChange(){
                // this.preLoad() ;
            }

          },
        beforeCreate() {
            this.isEmpty=false;
        }
    }

</script>
